--	Chat Watcher - based upon tradeshout in WOW
--
--	Author:			@lintydruid
--
--	Description:	monitors chat for notifications and announces them
--
--	Usage Notes:	/cwatch 		- Access command line
--			
--
--
--  Props : Thank you to @Dysrel for an excellent example project.
--
--	GLOBALS & LOCALS



-- create global CW object
cwatch = { }
cwatch.vars={};
cwatch.vars.adverts={};
cwatch.BroadcastQ={}
cwatch.NewMessages=0;

cwatch.showdebug=false

cwatch.dataStrucVer=0.4

cwatch.stats={checked=0, rejected=0, forwarded=0, fromforward=0, added=0}

cwatch.defaults=
{
	
	dataStrucVer=0.4, -- used for data upgrades
	settigns={},
	alertconfig=ldrude_qmess.data
	
}
--	Initialisation Function
function cwatch.init( self, addOnName )
	
	
	
	if ( addOnName ~= "cwatch" ) then return end -- is it for this addon?

	--	Load saved vars
	cwatch.data = ZO_SavedVars:New( "cwatch_data" , 1 , nil , cwatch.defaults , nil )
	
	-- Data Clean-up/Upgrade
	
	if (cwatch.data.dataStrucVer<cwatch.dataStrucVer) then
		cwatch.upgradeData();
	end
	
	cwatch_lang_Init();
	
	
	cwatch.vars.StdFilterCount = #cwatch.lang.Filters 
	
	--------- Register Events -------------------
	
	EVENT_MANAGER:RegisterForEvent( "cwatch" , EVENT_CHAT_MESSAGE_CHANNEL, cwatch.onChat)
	
	
	----------------------Configure Alert Box----------------------
	
	 ldrude_qmess.RegisterForConfigChangeEvent(cwatch.qmess_data_changed)
	 
	 ldrude_qmess.Config(cwatch.data.alertconfig)
	 
	 cwatch.config.create()
	 
	 cwatch.utils:LoadCustomLists()
	
	cwatch.debug("Initialised")
	
end

function  cwatch.qmess_data_changed(value)
	cwatch.data.alertconfig=value
end
--  maintain data structures
function cwatch.upgradeData()
	
	if (cwatch.data.dataStrucVer<0.2) then -- initial upgrade
		cwatch.data.settings={
				WhisperMessage="",
				FilterLevel=45,
				ChatShout=true,
				ShowTrade=true,
				ShowGuild=true,
				ShowLFG=true,
				ShowAlert=true,
				CustomWhiteList="",
				CustomBlackList="",
				CustomAchs={},
				ForwardMessages=true,
				MyAdverts={},
				}; 
				
		cwatch.data.dataStrucVer=0.2;
		
	elseif (cwatch.data.dataStrucVer<0.4) then -- initial upgrade
		cwatch.data.alertconfig=ldrude_qmess.data
		cwatch.data.dataStrucVer=0.4;
	elseif (cwatch.data.dataStrucVer<0.5) then -- initial upgrade
		cwatch.data.settings.ShowGuildAlerts=true
		cwatch.data.settings.ShowWispers=true
		cwatch.data.dataStrucVer=0.5;
	end
	


	cwatch.debug("Data Upgraded")
end

function cwatch.message (text)
	d (text)
end

function cwatch.debug (text)
	if cwatch.showdebug==true then
		d ("|c0000CCcwatch debug :: |r"..text)
	end
end

function cwatch.error (text)
	
		d ("|cFF0000cwatch error :: |r"..text)
	
end



function cwatch.cmd( text )

	cmd_text=text; -- keep pure copy
	
	text = string.upper(text)
	

	if text=="" then 
		cwatch.message("cwatch command line to follow.")
	
	elseif text=="STATUS" then 
		cwatch.message("data version :"..cwatch.data.dataStrucVer)
		cwatch.message("Player :"..GetUnitName("player"))
		cwatch.message("Raw :"..GetRawUnitName("player"))
		cwatch.message("Level :"..GetUnitLevel("player"))
	elseif string.sub(text,1,4)=="MESS" then
		cwatch.message("Test Message ->> "..string.sub(cmd_text,6))
		ldrude_qmess.add(string.sub(text,6),"/esoui/art/campaign/campaignbrowser_guestcampaign.dds",1500);
	elseif string.sub(text,1,4)=="PLAY" then 
		PlaySound(string.sub(cmd_text,6))
		cwatch.message("cwatch --> playing |c00ff00"..string.sub(cmd_text,5).."|r")
	elseif text=="DEBUG ON" then 
		cwatch.message("cwatch --> debug |c00ff00on|r")
		cwatch.showdebug=true
		cwatch.debug("Outputing debug.")
	elseif text=="DEBUG OFF" then 
		cwatch.message("cwatch --> debug |cff0000off|r")
		cwatch.showdebug=false
	else
		cwatch.error("command not recognised!")
	end
end


function cwatch.onChat(id, msgType, msgSource, msgText) -- EVENT_CHAT_MESSAGE_CHANNEL (integer messageType, string fromName, string text)

	cwatch.debug("Message --> ["..msgType.."] ["..msgSource.."] "..string.gsub(msgText,"|","#"))
--	PlaySound("bell")
	
	cwatch.AdvertAdd(msgText,msgSource,msgType)
	
	if (msgType==2 and cwatch.data.settings.ShowWispers) then -- wisper
		ldrude_qmess.add("|cff00ff["..string.gsub(msgSource,"(^.*)","").."] "..msgText.."|r","/esoui/art/campaign/campaignbrowser_guestcampaign.dds",1500)
		return
	end

	if (msgType==12 and cwatch.data.settings.ShowGuildAlerts) then -- guild
		ldrude_qmess.add("|c00ff00["..string.gsub(msgSource,"(^.*)","").."] "..msgText.."|r","/esoui/art/campaign/campaignbrowser_guestcampaign.dds",1500)
		return
	end
	
	
end
--------------------------------Utils -----------------------------------------------

cwatch.utils={}

function cwatch.utils:SafeNil(StringVar)
		if (StringVar== nil) then
			return "";
		end

		return StringVar;
end 

function cwatch.utils:TimeString(secs)

	if (secs==nil) then
		return "-";
	end
	
	if (secs<60) then
		return secs..cwatch.lang.Seconds;
	end
		
	
	
	local mins=math.floor(secs/60);
	local hours=0;
	local days=0;

	hours,mins=math.modf(mins/60);
	mins=math.floor(mins*60);

	days,hours=math.modf(hours/24);

	hours=math.floor(hours*24);

	sret=""
	if (days>0) then
		sret=days..cwatch.lang.Days.." ";
	end

	if (hours>0 or days>0) then
		sret=sret..hours..cwatch.lang.Hours.." ";
	end

	sret=sret..mins..cwatch.lang.Minutes;

return sret;




end

function cwatch.utils:Explode(delimiter, text)
  local list = {}; local pos = 1
  
  if text=="" then
    return {}
  end

  while 1 do
    local first, last = string.find(text, delimiter, pos)
    if first then
      table.insert(list, string.sub(text, pos, first-1))
      pos = last+1
    else
      table.insert(list, string.sub(text, pos))
      break
    end
  end
  return list
end

--------------------------Custom White/Black List Management-----------------------------
function cwatch.utils:SetCustomBlackList(data)

	cwatch.data.settings.CustomBlackList=data
	
	cwatch.utils:LoadCustomLists()
end

function cwatch.utils:SetCustomWhiteList(data)

	cwatch.data.settings.CustomWhiteList=data
	
	cwatch.utils:LoadCustomLists()
end


function cwatch.utils:LoadCustomLists()

	cwatch.vars.whitelist=cwatch.utils:Explode(";", cwatch.data.settings.CustomWhiteList)
	cwatch.vars.blacklist=cwatch.utils:Explode(";", cwatch.data.settings.CustomBlackList)

	--- Clear out old custom lists from search list (global cwatch.lang.Filters)
	ub = #cwatch.lang.Filters 
	if cwatch.vars.StdFilterCount<ub then
		for n=cwatch.vars.StdFilterCount+1,ub do
			
				table.remove(cwatch.lang.Filters, #cwatch.lang.Filters) --- delete custom filter

		end
	end
	---Add white list
	if #cwatch.vars.whitelist>0 then
		for n=1,#cwatch.vars.whitelist do
			table.insert(cwatch.lang.Filters,
				{F1=string.upper(cwatch.vars.whitelist[n]),F2="",F3="",F4="",F5="", Type=99, lStart=0, lEnd=999, Score=200, SingleWord=true})
			
		end
	end
	---Add black list
	if #cwatch.vars.blacklist>0 then
		for n=1,#cwatch.vars.blacklist do
			table.insert(cwatch.lang.Filters,
				{F1=string.upper(cwatch.vars.blacklist[n]),F2="",F3="",F4="",F5="", Type=99, lStart=0, lEnd=999, Score=-200, SingleWord=true})
			
		end
	end
	
	


end

--------------------------Advert Manager-------------------------------
function cwatch.utils.TrimAdvert(txtAdvert, tSize)


	if string.len(txtAdvert)<=tSize then
		return txtAdvert;
	end
	
	strlink="|%x+|H.-|H.-|H|R";
	tNewSize=tSize;
	
	spos,epos=string.find(string.upper(txtAdvert),strlink);
	while spos~=nil do
		if (tSize>=spos and tSize<=epos) then 
			tNewSize=epos;
		end
		spos,epos=string.find(string.upper(txtAdvert),strlink,epos);
	
	end
	
	return string.sub(txtAdvert,1,tNewSize).."...";
	
	

end

function cwatch.utils:ClearAdverts() 
	--cwatch.lDBObject.text = "0"
	cwatch.vars.adverts={}
	
	
end

--------------------------------Main Manager Code ------------------------------------------


function cwatch.AdvertAdd(pmessage,psender,pchannel)

	
	cwatch.stats.checked=cwatch.stats.checked+1 --- increment stats
	cwatch.stats.rejected=cwatch.stats.rejected+1 --- increment stats - assume rejected until added
	
	--Translate Forwarded Messages
	local msgfwd=false
	cpos,cend =string.find(string.upper(pchannel),"LFGSHOUT",1)
	local isLFGShoutChan= (cpos~=nil)
	
	
	
	--cwatch.utils:Debug(2,"Channel: "..pchannel);
	--cwatch.utils:Debug(2,"Sender: "..psender);
	
	
	if (isLFGShoutChan and string.sub(pmessage,1,5)=="FWD:[") then --- cache last 40 messages sent
		
		cwatch.stats.fromforward=cwatch.stats.fromforward+1 --- increment stats
		
		if (#LFGShout.BroadcastCache>39) then tremove(LFGShout.BroadcastCache,1) end;
		
		table.insert(LFGShout.BroadcastCache,pmessage)
		
	end
	
	--if (UnitAffectingCombat("PLAYER")) then return end;  -- Lag protection, no recording whilst in combat
	
	if (isLFGShoutChan and ((psender==GetUnitName("PLAYER") or psender==GetRawUnitName("PLAYER")) and cwatch.debug~=true) and string.sub(pmessage,1,5)=="FWD:[") then  return end; -- discard no formatted messages
	
	if ( isLFGShoutChan and ((psender==GetUnitName("PLAYER") or psender==GetRawUnitName("PLAYER") )or cwatch.debug==true) and string.sub(pmessage,1,5)=="FWD:[") then
		--cwatch.utils:Debug(2,"Forwarded!");
		
		msgfwd=true
		
		spos=string.find(pmessage,"]")
		
		if spos~=nil then
		
			psender=string.sub(pmessage,6, spos-1)
			pmessage=string.sub(pmessage,spos+1)
			
			--cwatch.utils:Debug(2,"FW Sender: "..psender);
			--cwatch.utils:Debug(2,"FW Message: "..pmessage);
		else
			return
		
		end

	end
	
	
	
	
	
	--Unit Level
	
	plev=GetUnitLevel("PLAYER")
	-- Filter out own messages
	if ((psender==GetUnitName("PLAYER") or psender==GetRawUnitName("PLAYER")) and  cwatch.debug~=true) then
		return;
	end
	
	
	
	--- Check for duplicates
	local isdupl=false;
	
	--Write
	umess=string.upper(pmessage);
	--cwatch.utils:Debug(2,pmessage);

	totScore=0;
	rawScore=0;
	msgType=0;
	
	if (pchannel~=nil and string.find(pchannel,cwatch.lang.LFGChannelText,1,true)~=nil) then
		--cwatch.utils:Debug(2,"LFG Channel");
		totScore=25;
	end
	
	 for n=1,#cwatch.lang.Filters do
		--cwatch.utils:Debug(2,"Filter:"..n);
		
		if (cwatch.lang.Filters[n].lStart<=plev and cwatch.lang.Filters[n].lEnd>=plev) then
			
								
			 --cwatch.debug("Filter L:"..cwatch.lang.Filters[n].F1);
			local spos=nil;
			local epos = nil;
			
			if (cwatch.lang.Filters[n].SingleWord==false) then ---Filter is a link or complex expression
			
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F1)~="" then 
							spos,epos=string.find(umess,cwatch.lang.Filters[n].F1,1)
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F2)~="" then 
					if spos==nil then spos,epos=string.find(umess,cwatch.lang.Filters[n].F2,1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F3)~="" then 
					if spos==nil then spos,epos=string.find(umess,cwatch.lang.Filters[n].F3,1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F4)~="" then 
					if spos==nil then spos,epos=string.find(umess,cwatch.lang.Filters[n].F4,1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F5)~="" then 
					if spos==nil then spos,epos=string.find(umess,cwatch.lang.Filters[n].F5,1) end
				end
			
			else
			
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F1)~="" then 
					spos,epos=string.find(" "..umess.." ","[%s%\\%./,%?]"..cwatch.lang.Filters[n].F1.."[%s%\\%./,%?]",1)
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F2)~="" then 
					if spos==nil then spos,epos=string.find(" "..umess.." ","[%s%\\%./,%?]"..cwatch.lang.Filters[n].F2.."[%s%\\%./,%?]",1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F3)~="" then 
					if spos==nil then spos,epos=string.find(" "..umess.." ","[%s%\\%./,%?]"..cwatch.lang.Filters[n].F3.."[%s%\\%./,%?]",1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F4)~="" then 
					if spos==nil then spos,epos=string.find(" "..umess.." ","[%s%\\%./,%?]"..cwatch.lang.Filters[n].F4.."[%s%\\%./,%?]",1) end
				end
				
				if cwatch.utils:SafeNil(cwatch.lang.Filters[n].F5)~="" then 
					if spos==nil then spos,epos=string.find(" "..umess.." ","[%s%\\%./,%?]"..cwatch.lang.Filters[n].F5.."[%s%\\%./,%?]",1) end
				end
			end
			
			if (spos~=nil) then
				
					
					totScore=totScore+cwatch.lang.Filters[n].Score
					
					cwatch.debug("text detected ["..n.."] Found '"..string.sub(umess,spos-1, epos-1).."' - score of "..cwatch.lang.Filters[n].Score)
					
					if cwatch.lang.Filters[n].Type~=99 then rawScore=rawScore+cwatch.lang.Filters[n].Score end --Only include system filters
					
					if (msgType<cwatch.lang.Filters[n].Type) then msgType=cwatch.lang.Filters[n].Type end
			else
				 --cwatch.debug("Failed ["..n.."]: '"..string.gsub(umess,"|", "||").."'")
			end
			
			
		
		end
	end	
	

	
	local mtime=nil;
	
	cwatch.debug("Score:"..totScore);
	cwatch.debug("Type:"..msgType);
	
	if (rawScore>44 and cwatch.data.settings.ForwardMessages and msgfwd==false and isLFGShoutChan==false) then
		
		
		bcmsg={sender=psender, message=pmessage, time=mtime}
		
		table.insert(cwatch.BroadcastQ,1,bcmsg); --- add a message onto the broadcast Q
		--cwatch.utils:Debug(2,"Added to broadcast Q : len "..#LFGShout.BroadcastQ);
	end
	
	if (totScore<cwatch.data.settings.FilterLevel) then --filter out - score too low.
		return;
	end
	
	if (cwatch.data.settings.ShowTrade==false and (msgType==1 or msgType==2)) then -- filter out - trade
		return
	end
	
	if (cwatch.data.settings.ShowGuild==false and msgType==5) then -- filter out - Guild
		return
	end
	
	if (cwatch.data.settings.ShowLFG==false and (msgType==3 or msgType==4)) then -- filter out - LFG and Quest
		return
	end
	
	
	tAdvert={time=0; player="",shortmessage="",msgtype=0,score=0,message="",channel="",color="", class="", count=1, Changed=true};

	pmessage=string.gsub(pmessage,"<","[");
	pmessage=string.gsub(pmessage,">","]");
	pmessage=string.gsub(pmessage,"/","\\");
	pmessage=string.gsub(pmessage,"&","+");

	
	tAdvert.shortmessage=cwatch.utils.TrimAdvert(pmessage,80)
	tAdvert.time = mtime;
	tAdvert.player=psender;
	tAdvert.channel=pchannel;
	tAdvert.Score=totScore;
	tAdvert.msgType=msgType;
	
	if (msgType==1) then --- Buy
		tAdvert.color="FFC000";
	elseif (msgType==2) then --- Sell
		tAdvert.color="FF8000";
	elseif (msgType==3) then --- Instance/LFG
		tAdvert.color="00FF00";
	elseif (msgType==4) then --- Quest
		tAdvert.color="FFFF00";
	elseif (msgType==5) then --- Guild
		tAdvert.color="ff80ff";
	elseif (msgType==99) then --- Guild
		tAdvert.color="E9323C";
	else
		tAdvert.color="FFFFFF";
	end
	
	pcolor=tAdvert.color;
	
	--tAdvert.class=pclass;
	tAdvert.message=pmessage;
	
	
	isdupl=false
	
	if  cwatch.vars.adverts ~= nil then
		for i=1, #cwatch.vars.adverts do
			if (cwatch.vars.adverts[i].player==psender) then
				
				tAdvert.Changed =  not (cwatch.vars.adverts[i].message==pmessage) -- is it a new message?
				tAdvert.Changed = tAdvert.Changed or cwatch.vars.adverts[i].Changed
				
				if not msgfwd then tAdvert.count=cwatch.vars.adverts[i].count+1 end;
				
				table.remove(cwatch.vars.adverts,i);
				table.insert(cwatch.vars.adverts,1,tAdvert);
				
				
			
				isdupl =true;
				break;
			end
		end	
	end
	
	
	if  (not isdupl) then		
			cwatch.stats.rejected=cwatch.stats.rejected-1 --- decrement stats because added
			cwatch.stats.added=cwatch.stats.added+1
			table.insert(cwatch.vars.adverts,1,tAdvert);

	end
	

	
	
	if (cwatch.vars.adverts ~= nil and #cwatch.vars.adverts>40) then
		table.remove(cwatch.vars.adverts);
	end
	
	cwatch.debug("|cFFC000--> cwatch: |c"..pcolor.."|r["..psender.."] "..pmessage.."|cFFC000 <--|r")
	
	--cwatch.utils:Debug(2,"Shouting");
	if (cwatch.data.settings.ChatShout) then
		--DEFAULT_CHAT_FRAME:AddMessage("|cffFFC000--> LFG Shout: |cff"..pcolor.."|Hplayer:"..psender.."|h["..psender.."]|h "..pmessage.."|cffFFC000 <--|r");
		cwatch.message("|cFFC000--> cwatch: |c"..pcolor.."|r["..psender.."] "..pmessage.."|cFFC000 <--|r")
		
	end
	
	if cwatch.data.settings.ShowAlert then 
	---	UIErrorsFrame:AddMessage("|cFFFFFFFF["..psender.."]|cff"..pcolor..pmessage);
		ldrude_qmess.add("|c"..pcolor.."|r["..psender.."] "..pmessage.."|r","/esoui/art/campaign/campaignbrowser_guestcampaign.dds",1500)
	end
	
	
	if msgType<99 then
		--PlaySound("TellMessage");
	else
		--PlaySound("igBonusBarOpen");
	end
	
	
	---Manage new message count.
	cwatch.NewMessages= 0
	for i=1, #cwatch.vars.adverts do
		if cwatch.vars.adverts[i].Changed then cwatch.NewMessages= cwatch.NewMessages+1 end;
	end
	
	if cwatch.NewMessages>0 then
	--	LFGShout.lDBObject.text = "|cff00ff00"..LFGShout.NewMessages 
	else
	--	LFGShout.lDBObject.text = "0"
		
	end

end



-------------------------------- Init Code --------------------------------------------------
--	Register Init
EVENT_MANAGER:RegisterForEvent( "cwatch" , EVENT_ADD_ON_LOADED , cwatch.init )




-- Slash Commands --
SLASH_COMMANDS["/cwatch"] =  cwatch.cmd
SLASH_COMMANDS["/cw"] =  cwatch.cmd
cwatch.debug("Init Code Complete");
